/********************************************************************
   TORNADO-PX5421Q DCM Demo Utility. rev.1A
   Host application for T-PX/DDC4 and TORNADO-3x/E3x/P3x.
  (C) MicroLAB Systems, 2001

   Host C3x: load default reset program to all C5421Q DSP cores.
 

   file:
   -----
   	Host TORNADO-3x/E3x/P3x code.

   Description:
   ------------
	This demo sets all C5421 DSP cores to the RESET state and loads default program
	to the C5421 on-chip DSP memory via HPI port.

   Host TORNADO platform:
   ----------------------
	This demo utilize host TORNADO resources and runs in HOST mode.
	MIRAGE emulator or COFF-loader shall be used to upload
	code to host TORNADO board.

	This demo does not utilize T-PX5421Q on-board DSP resources. 

	TI CCS tools are required to recompile this demo.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  Demo and Signal Parameters:
  ---------------------------
	  - DCM is installed onto TORNADO-3x/E3x/P3x mainboard
***********************************************************************/


#include <c3x_def.h>
#include <t3x_dsp.h>

// define C3x DSP platform and load PX5421Q host utilities
#define	_HOST_C3X_DSP_	1
#include <px5421qh.h>


init_cpu()
{
   *C3X_PBUS_GC=T3X_PBUS_GC_DATA;
}





int n=0;	// is used for tracking error conditions


main()
{ unsigned d,i;
  int err;


   init_cpu();
   err=HTPX5421Q_OK;

	// set all T-PX5421Q DSP cores to the RESET state
   n=0;
   HTPX5421Q_SET_DSP_MRESET_ALL;
   HTPX5421Q_SET_HPI_RESET;
   HTPX5421Q_SET_HPI_ERR_EN_ON;
   HTPX5421Q_CLR_HPI_ERR_ALL;
   HTPX5421Q_SET_HIRQ_EN_OFF_ALL;

   if(	 HTPX5421Q_CNTR1_RG_DATA!=HTPX5421Q_DSP_MRESET_RESET_ALL
	  || HTPX5421Q_CNTR2_RG_DATA!=(HTPX5421Q_HPI_ERR_EN_ON | HTPX5421Q_HPI_RESET_RESET)
	  || HTPX5421Q_HINT_STAT_RG_DATA!=0
	  || HTPX5421Q_HPI_ERR_STAT_RG_DATA!=0
	  || HTPX5421Q_HIRQ_EN_RG_DATA!=0
	 ) 
		goto error;

	// now release HPI_RESET and load default reset program
	// Note: it is OK to load default DSP program to the CPU-A core of each 
	//       C5421 DSP only due to the shared P-RAM area at DSP reset vector area.
   HTPX5421Q_SET_HPI_GO;
   for(i=0;i<8;i+=2)
	{
	   n=11;
		if((err=HTPX5421Q_load_default_program(i))!=HTPX5421Q_OK)
			goto error;

		//check for DSP error
	   n=12;
		if(HTPX5421Q_HPI_ERR_STAT_RG_DATA) 
			goto error;
	}

	// now release all DSP RESET signals and put all DSPs to the RUN state
   n=13;
   HTPX5421Q_SET_DSP_MGO_ALL;
   
	//---------------- execution trap code ------------

  exit_ok:	// get here on successful execution
    while(1);

  error:	// get here on any error occured (analyze N var data)
    while(1) ;

}


