/*************************************************************************
  TORNADO-PX5421Q DSP Core-to-core communication test via McBSP2 ports.
  (C) MicroLAB Systems, 2001

  file: master core

	Notes:
	------
	This MASTER utility must operate in conjunction with the corresponding
	SLAVE utility. The following are the DSP core pairs, which can be used to
	load MASTER-SLAVE core-to-core communication test:
			McBSP2@DSP0A <--> McBSP2@DSP1A
			McBSP2@DSP0B <--> McBSP2@DSP2B
			McBSP2@DSP2A <--> McBSP2@DSP3A
			McBSP2@DSP1B <--> McBSP2@DSP3B

	For example, McBSP2@DSP0A DSP core mus be loaded with the MASTER demo, 
	whereas McBSP2@DSP1A core must be loaded with the SLAVE demo. After loading,
	the SLAVE demo must be run prior running the MASTER demo.

	This test does not require any host TORNADO DSP activty.

*************************************************************************/

#include "c54x_def.h"
#include "px5421qd.h"


unsigned *pass_counter;

#define	PASS_COUNTER_ADDR		0x1800

// data array for test tranfers
unsigned d[] = { 0x1234, 0x4321, 0x9876, 0x6789,
				 0xabcd, 0xef01, 0x29a3, 0xaaaa };

#define	NUMBER_OF_TEST_WORDS	8

#define	XOR_TEST_PATTERN		0x5555

main()
{ int i;
  unsigned rd;

   pass_counter = (unsigned *)PASS_COUNTER_ADDR;
   (*pass_counter) = 0;

	// init DSP and configure McBSP2
   TPX5421Q_init_dsp();
   TPX5421Q_init_mcbsp2();

   while(1)
    {
		for(i=0;i<NUMBER_OF_TEST_WORDS;i++)
			{
				// transmit data as the MASTER
				TPX5421Q_write_mcbsp2_data(d[i]);

				// receive data and verify against expected XORed value
				if(TPX5421Q_read_mcbsp2_data()!=(d[i] ^ XOR_TEST_PATTERN)) goto error;
			}

	     (*pass_counter)++;
    }

error:
	while(1);

}



