/********************************************************************
   TORNADO-PX5421Q DCM Demo Utility. rev.1A
   Host application for T-PX5421Q and TORNADO-3x/E3x/P3x.
  (C) MicroLAB Systems, 2001

   Host C3x: load and starts combine SIOX test for particular DSP core.
 

   file:
   -----
   	Host TORNADO-3x/E3x/P3x code.

   Description:
   ------------
	This demo loads and starts combined SIOX test to particular C5421 DSP
	core via  host TORNADO-3x/E3x/P3x DSP system using C-BSF loader.

   Host TORNADO platform:
   ----------------------
	This demo utilize host TORNADO resources and runs in HOST mode.
	MIRAGE emulator or COFF-loader shall be used to upload
	code to host TORNADO board.

	This demo does not utilize T-PX5421Q on-board DSP resources. 

	TI CCS tools are required to recompile this demo.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  Demo and Signal Parameters:
  ---------------------------
	  - DCM is installed onto TORNADO-3x/E3x/P3x mainboard
***********************************************************************/


#include <c3x_def.h>
#include <t3x_dsp.h>

// define C3x DSP platform and load PX5421Q host utilities
#define	_HOST_C3X_DSP_	1
#include <px5421qh.h>


#include "px54_sx.cbs"		

// define DSP core, which will be involved into the test.
#define TARGET_DSP_CORE		HTPX5421Q_DSP0A


init_cpu()
{
   *C3X_PBUS_GC=T3X_PBUS_GC_DATA;
}



int n=0;	// is used for tracking error conditions

main()
{ unsigned d,i;
  int err;


   init_cpu();
   err=HTPX5421Q_OK;

	// set all T-PX5421Q DSP cores to the RESET state
   n=0;
   if(HTPX5421Q_init()!=HTPX5421Q_OK)
		goto error;

	// now release HPI_RESET and load SIOX reset test
   HTPX5421Q_SET_HPI_GO;
   n=11;
	
		// load combned SIOX test using C-BSF loader
   if((err=HTPX5421Q_load_program(TARGET_DSP_CORE,C54X_CBSF_DATA))!=HTPX5421Q_OK)
			goto error;

	//check for DSP error
   n=12;
   if(HTPX5421Q_HPI_ERR_DATA(TARGET_DSP_CORE/2)) 
			goto error;

	// now release all DSP RESET signals and put all DSPs to the RUN state
   n=13;
   HTPX5421Q_SET_DSP_MGO(TARGET_DSP_CORE);
   
	//---------------- execution trap code ------------

  exit_ok:	// get here on successful execution
    while(1);

  error:	// get here on any error occured (analyze N var data)
    while(1) ;

}


