/********************************************************************
   TORNADO-PX5421Q DCM Demo Utility. rev.1A
   Host I/F registers scam test for TORNADO-3x/E3x/P3x.
   (C) MicroLAB Systems, 2001


   Description:
   ------------
	This demo performs host I/F registers test via host
	TORNADO-3x/E3x/P3x mainboard. T-PX5421Q on-board DSPs 
	are not utilized for this demo.

   Host TORNADO platform:
   ----------------------
	This demo utilize host TORNADO resources and runs in HOST mode.
	MIRAGE emulator or COFF-loader shall be used to upload
	code to host TORNADO board.

	TI CCS tools are required to recompile this demo and to
	upload code to host TORNADO on-board DSP environment.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  Demo and Signal Parameters:
  ---------------------------
	  - DCM is installed onto TORNADO-3x/E3x/P3x mainboard
***********************************************************************/




#include <c3x_def.h>
#include <t3x_dsp.h>

// define C3x DSP platform and load PX5421Q host utilities
#define	_HOST_C3X_DSP_	1

#include <px5421qh.h>



init_cpu()
{
   *C3X_PBUS_GC=T3X_PBUS_GC_DATA;
}

int n=0;	// is used for tracking error conditions


main()
{ int i,j,k;
  unsigned d;

   init_cpu();

 while(1)
 {

   n=0;

	// reset all registers initially
   HTPX5421Q_SET_DSP_MRESET_ALL;
   HTPX5421Q_SET_HPI_RESET;
   HTPX5421Q_SET_HPI_ERR_EN_OFF;
   HTPX5421Q_CLR_HPI_ERR_ALL;
   HTPX5421Q_SET_HIRQ_EN_OFF_ALL;
   HTPX5421Q_SET_HIRQ0_IE1_RG(HTPX5421Q_HINT_IE_OFF_ALL);
   HTPX5421Q_SET_HIRQ1_IE1_RG(HTPX5421Q_HINT_IE_OFF_ALL);
   HTPX5421Q_SET_HIRQ2_IE1_RG(HTPX5421Q_HINT_IE_OFF_ALL);
   HTPX5421Q_SET_HIRQ3_IE1_RG(HTPX5421Q_HINT_IE_OFF_ALL);
   HTPX5421Q_SET_HIRQ0_IE2_RG(HTPX5421Q_HPI_ERR_IE_OFF);
   HTPX5421Q_SET_HIRQ1_IE2_RG(HTPX5421Q_HPI_ERR_IE_OFF);
   HTPX5421Q_SET_HIRQ2_IE2_RG(HTPX5421Q_HPI_ERR_IE_OFF);
   HTPX5421Q_SET_HIRQ3_IE2_RG(HTPX5421Q_HPI_ERR_IE_OFF);

   if(	 HTPX5421Q_CNTR1_RG_DATA!=HTPX5421Q_DSP_MRESET_RESET_ALL
	  || HTPX5421Q_CNTR2_RG_DATA!=0
	  || HTPX5421Q_HINT_STAT_RG_DATA!=0
	  || HTPX5421Q_HPI_ERR_STAT_RG_DATA!=0
	  || HTPX5421Q_HIRQ_EN_RG_DATA!=0
	  || HTPX5421Q_HIRQ0_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ1_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ2_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ3_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ0_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ1_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ2_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ3_IE2_RG_DATA!=0
	 ) 
		goto error;



	n=1;
	// test CONTROL #1 register
   for(i=0,d=0x1;i<8;i++)
     {
       HTPX5421Q_SET_CNTR1_RG(d);
       if(   HTPX5421Q_CNTR1_RG_DATA!=d
		  || HTPX5421Q_CNTR2_RG_DATA!=0
		  || HTPX5421Q_HIRQ_EN_RG_DATA!=0
		  || HTPX5421Q_HIRQ0_IE1_RG_DATA!=0
		  || HTPX5421Q_HIRQ1_IE1_RG_DATA!=0
	  	  || HTPX5421Q_HIRQ2_IE1_RG_DATA!=0
		  || HTPX5421Q_HIRQ3_IE1_RG_DATA!=0
		  || HTPX5421Q_HIRQ0_IE2_RG_DATA!=0
		  || HTPX5421Q_HIRQ1_IE2_RG_DATA!=0
		  || HTPX5421Q_HIRQ2_IE2_RG_DATA!=0
		  || HTPX5421Q_HIRQ3_IE2_RG_DATA!=0
         ) 
			goto error;
       d <<= 1;
     }

   n=2;
   HTPX5421Q_SET_CNTR1_RG(0);
   if(	 HTPX5421Q_CNTR1_RG_DATA!=0
	  || HTPX5421Q_CNTR2_RG_DATA!=0
	  || HTPX5421Q_HIRQ_EN_RG_DATA!=0
	  || HTPX5421Q_HIRQ0_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ1_IE1_RG_DATA!=0
  	  || HTPX5421Q_HIRQ2_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ3_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ0_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ1_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ2_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ3_IE2_RG_DATA!=0
     ) 
      goto error;

	n=3;

	// test CONTROL #2 register
   HTPX5421Q_SET_HPI_GO;
   if(   HTPX5421Q_CNTR2_RG_DATA!=HTPX5421Q_HPI_RESET_GO
	  || HTPX5421Q_CNTR1_RG_DATA!=0
	  || HTPX5421Q_HIRQ_EN_RG_DATA!=0
	  || HTPX5421Q_HIRQ0_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ1_IE1_RG_DATA!=0
  	  || HTPX5421Q_HIRQ2_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ3_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ0_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ1_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ2_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ3_IE2_RG_DATA!=0
     ) 
		goto error;

	n=4;
   HTPX5421Q_SET_HPI_RESET;
   if(   HTPX5421Q_CNTR2_RG_DATA!=HTPX5421Q_HPI_RESET_RESET
	  || HTPX5421Q_CNTR1_RG_DATA!=0
	  || HTPX5421Q_HIRQ_EN_RG_DATA!=0
	  || HTPX5421Q_HIRQ0_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ1_IE1_RG_DATA!=0
  	  || HTPX5421Q_HIRQ2_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ3_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ0_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ1_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ2_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ3_IE2_RG_DATA!=0
     ) 
		goto error;

	n=5;

   HTPX5421Q_SET_HPI_ERR_EN_ON;
   if(   HTPX5421Q_CNTR2_RG_DATA!=HTPX5421Q_HPI_ERR_EN_ON
	  || HTPX5421Q_CNTR1_RG_DATA!=0
	  || HTPX5421Q_HIRQ_EN_RG_DATA!=0
	  || HTPX5421Q_HIRQ0_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ1_IE1_RG_DATA!=0
  	  || HTPX5421Q_HIRQ2_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ3_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ0_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ1_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ2_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ3_IE2_RG_DATA!=0
     ) 
		goto error;

	n=6;
   HTPX5421Q_SET_HPI_ERR_EN_OFF;
   if(   HTPX5421Q_CNTR2_RG_DATA!=HTPX5421Q_HPI_ERR_EN_OFF
	  || HTPX5421Q_CNTR1_RG_DATA!=0
	  || HTPX5421Q_HIRQ_EN_RG_DATA!=0
	  || HTPX5421Q_HIRQ0_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ1_IE1_RG_DATA!=0
  	  || HTPX5421Q_HIRQ2_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ3_IE1_RG_DATA!=0
	  || HTPX5421Q_HIRQ0_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ1_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ2_IE2_RG_DATA!=0
	  || HTPX5421Q_HIRQ3_IE2_RG_DATA!=0
     ) 
		goto error;

	n=7;

	// test HIRQ_EN register
   for(i=0,d=0x1;i<4;i++)
     {
       HTPX5421Q_SET_HIRQ_EN_RG(d);
       if(	 HTPX5421Q_HIRQ_EN_RG_DATA!=d
		  || HTPX5421Q_CNTR1_RG_DATA!=0
		  || HTPX5421Q_CNTR2_RG_DATA!=0
		  || HTPX5421Q_HIRQ0_IE1_RG_DATA!=0
		  || HTPX5421Q_HIRQ1_IE1_RG_DATA!=0
  		  || HTPX5421Q_HIRQ2_IE1_RG_DATA!=0
		  || HTPX5421Q_HIRQ3_IE1_RG_DATA!=0
		  || HTPX5421Q_HIRQ0_IE2_RG_DATA!=0
		  || HTPX5421Q_HIRQ1_IE2_RG_DATA!=0
		  || HTPX5421Q_HIRQ2_IE2_RG_DATA!=0
		  || HTPX5421Q_HIRQ3_IE2_RG_DATA!=0
         ) 
			goto error;
       d <<= 1;
     }

	n=8;

   HTPX5421Q_SET_HIRQ_EN_RG(0);
   if(	   HTPX5421Q_HIRQ_EN_RG_DATA!=0
		|| HTPX5421Q_CNTR1_RG_DATA!=0
		|| HTPX5421Q_CNTR2_RG_DATA!=0
		|| HTPX5421Q_HIRQ0_IE1_RG_DATA!=0
		|| HTPX5421Q_HIRQ1_IE1_RG_DATA!=0
  		|| HTPX5421Q_HIRQ2_IE1_RG_DATA!=0
		|| HTPX5421Q_HIRQ3_IE1_RG_DATA!=0
		|| HTPX5421Q_HIRQ0_IE2_RG_DATA!=0
		|| HTPX5421Q_HIRQ1_IE2_RG_DATA!=0
		|| HTPX5421Q_HIRQ2_IE2_RG_DATA!=0
		|| HTPX5421Q_HIRQ3_IE2_RG_DATA!=0
     ) 
		goto error;



	// test IE registers
   for(j=0;j<4;j++)
	{
	   for(i=0,d=0x1;i<8;i++)
       {
	n=9;
	       HTPX5421Q_SET_HIRQ_IE1_RG(j,d);
    	   if(HTPX5421Q_HIRQ_IE1_RG_DATA(j)!=d) goto error;
		   
	       if(   HTPX5421Q_CNTR1_RG_DATA!=0
			  || HTPX5421Q_CNTR2_RG_DATA!=0
			  || HTPX5421Q_HIRQ_EN_RG_DATA!=0
	         ) 
				goto error;

	n=10;
		   for(k=0;k<4;k++)
			{
	    	   if(HTPX5421Q_HIRQ_IE2_RG_DATA(k)!=0) goto error;
				
			   if(k==j) continue;
	    	   if(HTPX5421Q_HIRQ_IE1_RG_DATA(k)!=0) goto error;
			}		   

       	   d <<= 1;
       }

	n=11;

       HTPX5421Q_SET_HIRQ_IE1_RG(j,0);
   	   if(HTPX5421Q_HIRQ_IE1_RG_DATA(j)!=0) goto error;

       if(   HTPX5421Q_CNTR1_RG_DATA!=0
		  || HTPX5421Q_CNTR2_RG_DATA!=0
		  || HTPX5421Q_HIRQ_EN_RG_DATA!=0
         ) 
			goto error;

	n=12;

	   for(k=0;k<4;k++)
		{
    	   if(HTPX5421Q_HIRQ_IE2_RG_DATA(k)!=0) goto error;
			
		   if(k==j) continue;
    	   if(HTPX5421Q_HIRQ_IE1_RG_DATA(k)!=0) goto error;
		}		   


	n=13;
		
       HTPX5421Q_SET_HIRQ_IE_ON(j,HTPX5421Q_HPI_ERR_IE);
   	   if(   HTPX5421Q_HIRQ_IE_DATA(j,HTPX5421Q_HPI_ERR_IE)!=HTPX5421Q_HPI_ERR_IE_ON
		  || HTPX5421Q_HIRQ_IE1_RG_DATA(j)!=0
         ) goto error;

	n=14;

       if(   HTPX5421Q_CNTR1_RG_DATA!=0
		  || HTPX5421Q_CNTR2_RG_DATA!=0
		  || HTPX5421Q_HIRQ_EN_RG_DATA!=0
         ) 
			goto error;

	n=15;
	   for(k=0;k<4;k++)
		{
		   if(k==j) continue;
    	   if(HTPX5421Q_HIRQ_IE1_RG_DATA(k)!=0) goto error;
		}		   


	n=16;
       HTPX5421Q_SET_HIRQ_IE_OFF(j,HTPX5421Q_HPI_ERR_IE);
   	   if(   HTPX5421Q_HIRQ_IE_DATA(j,HTPX5421Q_HPI_ERR_IE)!=HTPX5421Q_HPI_ERR_IE_OFF
		  || HTPX5421Q_HIRQ_IE1_RG_DATA(j)!=0
         ) goto error;

	n=17;
       if(   HTPX5421Q_CNTR1_RG_DATA!=0
		  || HTPX5421Q_CNTR2_RG_DATA!=0
		  || HTPX5421Q_HIRQ_EN_RG_DATA!=0
         ) 
			goto error;

	n=18;
	   for(k=0;k<4;k++)
		{
		   if(k==j) continue;
    	   if(HTPX5421Q_HIRQ_IE1_RG_DATA(k)!=0) goto error;
		}		   


	   n++;
	}


	n=19;

	// now set all regs to a random value and test the result
   HTPX5421Q_SET_CNTR1_RG(0x96);
   HTPX5421Q_SET_CNTR2_RG(0xff);
   HTPX5421Q_SET_HIRQ_EN_RG(0x55);
   HTPX5421Q_SET_HIRQ0_IE1_RG(0x78);
   HTPX5421Q_SET_HIRQ1_IE1_RG(0x23);
   HTPX5421Q_SET_HIRQ2_IE1_RG(0xfc);
   HTPX5421Q_SET_HIRQ3_IE1_RG(0xa4);
   HTPX5421Q_SET_HIRQ0_IE2_RG(HTPX5421Q_HPI_ERR_IE_OFF);
   HTPX5421Q_SET_HIRQ1_IE2_RG(HTPX5421Q_HPI_ERR_IE_ON);
   HTPX5421Q_SET_HIRQ2_IE2_RG(HTPX5421Q_HPI_ERR_IE_ON);
   HTPX5421Q_SET_HIRQ3_IE2_RG(HTPX5421Q_HPI_ERR_IE_OFF);

   if(	 HTPX5421Q_CNTR1_RG_DATA!=0x96
	  || HTPX5421Q_CNTR2_RG_DATA!=0x81
	  || HTPX5421Q_HIRQ_EN_RG_DATA!=0x5
	  || HTPX5421Q_HIRQ0_IE1_RG_DATA!=0x78
	  || HTPX5421Q_HIRQ1_IE1_RG_DATA!=0x23
	  || HTPX5421Q_HIRQ2_IE1_RG_DATA!=0xfc
	  || HTPX5421Q_HIRQ3_IE1_RG_DATA!=0xa4
	  || HTPX5421Q_HIRQ0_IE2_RG_DATA!=HTPX5421Q_HPI_ERR_IE_OFF
	  || HTPX5421Q_HIRQ1_IE2_RG_DATA!=HTPX5421Q_HPI_ERR_IE_ON
	  || HTPX5421Q_HIRQ2_IE2_RG_DATA!=HTPX5421Q_HPI_ERR_IE_ON
	  || HTPX5421Q_HIRQ3_IE2_RG_DATA!=HTPX5421Q_HPI_ERR_IE_OFF
	 ) 
		goto error;

 }

  error:
    while(1) ;

}


