/******************************************************
  TMS320C54x macros. rev.3.5
  (C) MicroLAB Systems Ltd, 1997-2001
*******************************************************/

#ifndef __C54X_DEF__
#define __C54X_DEF__	1

/************  C54x CPU & Peripheral Registers *****************/

//-------- BSP/TDM ports for C542/C548/C549 --------
unsigned *C54X_BSP_DRR	= (unsigned *)0x20;
unsigned *C54X_BSP_DXR	= (unsigned *)0x21;
unsigned *C54X_BSP_SPC	= (unsigned *)0x22;
unsigned *C54X_BSP_SPCE	= (unsigned *)0x23;
unsigned *C54X_BSP_AXR	= (unsigned *)0x38;
unsigned *C54X_BSP_BKX	= (unsigned *)0x39;
unsigned *C54X_BSP_ARR	= (unsigned *)0x3A;
unsigned *C54X_BSP_BKR	= (unsigned *)0x3B;

unsigned *C54X_BSP1_DRR	= (unsigned *)0x40;
unsigned *C54X_BSP1_DXR	= (unsigned *)0x41;
unsigned *C54X_BSP1_SPC	= (unsigned *)0x42;
unsigned *C54X_BSP1_SPCE= (unsigned *)0x43;
unsigned *C54X_BSP1_AXR	= (unsigned *)0x3c;
unsigned *C54X_BSP1_BKX	= (unsigned *)0x3d;
unsigned *C54X_BSP1_ARR	= (unsigned *)0x3e;
unsigned *C54X_BSP1_BKR	= (unsigned *)0x3f;

unsigned *C54X_TDM_TRCV	= (unsigned *)0x30;
unsigned *C54X_TDM_TDXR	= (unsigned *)0x31;
unsigned *C54X_TDM_TSPC	= (unsigned *)0x32;
unsigned *C54X_TDM_TCSR	= (unsigned *)0x33;
unsigned *C54X_TDM_TRTA	= (unsigned *)0x34;
unsigned *C54X_TDM_TRAD	= (unsigned *)0x35;

//-------- McBSP ports for C5402/C5410/C5416 --------
// Note, that C5402 has McBSP-0 and McBSP-1 ports only.
unsigned *C54X_MCBSP0_DRR2	= (unsigned *)0x20;
unsigned *C54X_MCBSP0_DRR1	= (unsigned *)0x21;
unsigned *C54X_MCBSP0_DXR2	= (unsigned *)0x22;
unsigned *C54X_MCBSP0_DXR1	= (unsigned *)0x23;
unsigned *C54X_MCBSP0_SPSA	= (unsigned *)0x38;
unsigned *C54X_MCBSP0_SPCR1	= (unsigned *)0x39;
unsigned *C54X_MCBSP0_SPCR2	= (unsigned *)0x39;
unsigned *C54X_MCBSP0_RCR1	= (unsigned *)0x39;
unsigned *C54X_MCBSP0_RCR2	= (unsigned *)0x39;
unsigned *C54X_MCBSP0_XCR1	= (unsigned *)0x39;
unsigned *C54X_MCBSP0_XCR2	= (unsigned *)0x39;
unsigned *C54X_MCBSP0_SRGR1	= (unsigned *)0x39;
unsigned *C54X_MCBSP0_SRGR2	= (unsigned *)0x39;
unsigned *C54X_MCBSP0_MCR1	= (unsigned *)0x39;
unsigned *C54X_MCBSP0_MCR2	= (unsigned *)0x39;
unsigned *C54X_MCBSP0_RCERA	= (unsigned *)0x39;
unsigned *C54X_MCBSP0_RCERB	= (unsigned *)0x39;
unsigned *C54X_MCBSP0_XCERA	= (unsigned *)0x39;
unsigned *C54X_MCBSP0_XCERB	= (unsigned *)0x39;
unsigned *C54X_MCBSP0_PCR	= (unsigned *)0x39;

unsigned *C54X_MCBSP1_DRR2	= (unsigned *)0x40;
unsigned *C54X_MCBSP1_DRR1	= (unsigned *)0x41;
unsigned *C54X_MCBSP1_DXR2	= (unsigned *)0x42;
unsigned *C54X_MCBSP1_DXR1	= (unsigned *)0x43;
unsigned *C54X_MCBSP1_SPSA	= (unsigned *)0x48;
unsigned *C54X_MCBSP1_SPCR1	= (unsigned *)0x49;
unsigned *C54X_MCBSP1_SPCR2	= (unsigned *)0x49;
unsigned *C54X_MCBSP1_RCR1	= (unsigned *)0x49;
unsigned *C54X_MCBSP1_RCR2	= (unsigned *)0x49;
unsigned *C54X_MCBSP1_XCR1	= (unsigned *)0x49;
unsigned *C54X_MCBSP1_XCR2	= (unsigned *)0x49;
unsigned *C54X_MCBSP1_SRGR1	= (unsigned *)0x49;
unsigned *C54X_MCBSP1_SRGR2	= (unsigned *)0x49;
unsigned *C54X_MCBSP1_MCR1	= (unsigned *)0x49;
unsigned *C54X_MCBSP1_MCR2	= (unsigned *)0x49;
unsigned *C54X_MCBSP1_RCERA	= (unsigned *)0x49;
unsigned *C54X_MCBSP1_RCERB	= (unsigned *)0x49;
unsigned *C54X_MCBSP1_XCERA	= (unsigned *)0x49;
unsigned *C54X_MCBSP1_XCERB	= (unsigned *)0x49;
unsigned *C54X_MCBSP1_PCR	= (unsigned *)0x49;

unsigned *C54X_MCBSP2_DRR2	= (unsigned *)0x30;
unsigned *C54X_MCBSP2_DRR1	= (unsigned *)0x31;
unsigned *C54X_MCBSP2_DXR2	= (unsigned *)0x32;
unsigned *C54X_MCBSP2_DXR1	= (unsigned *)0x33;
unsigned *C54X_MCBSP2_SPSA	= (unsigned *)0x34;
unsigned *C54X_MCBSP2_SPCR1	= (unsigned *)0x35;
unsigned *C54X_MCBSP2_SPCR2	= (unsigned *)0x35;
unsigned *C54X_MCBSP2_RCR1	= (unsigned *)0x35;
unsigned *C54X_MCBSP2_RCR2	= (unsigned *)0x35;
unsigned *C54X_MCBSP2_XCR1	= (unsigned *)0x35;
unsigned *C54X_MCBSP2_XCR2	= (unsigned *)0x35;
unsigned *C54X_MCBSP2_SRGR1	= (unsigned *)0x35;
unsigned *C54X_MCBSP2_SRGR2	= (unsigned *)0x35;
unsigned *C54X_MCBSP2_MCR1	= (unsigned *)0x35;
unsigned *C54X_MCBSP2_MCR2	= (unsigned *)0x35;
unsigned *C54X_MCBSP2_RCERA	= (unsigned *)0x35;
unsigned *C54X_MCBSP2_RCERB	= (unsigned *)0x35;
unsigned *C54X_MCBSP2_XCERA	= (unsigned *)0x35;
unsigned *C54X_MCBSP2_XCERB	= (unsigned *)0x35;
unsigned *C54X_MCBSP2_PCR	= (unsigned *)0x35;

#define	C54X_MCBSP_SBA_SPCR1		0
#define	C54X_MCBSP_SBA_SPCR2		1
#define	C54X_MCBSP_SBA_RCR1			2
#define	C54X_MCBSP_SBA_RCR2			3
#define	C54X_MCBSP_SBA_XCR1			4
#define	C54X_MCBSP_SBA_XCR2			5
#define	C54X_MCBSP_SBA_SRGR1		6
#define	C54X_MCBSP_SBA_SRGR2		7
#define	C54X_MCBSP_SBA_MCR1			8
#define	C54X_MCBSP_SBA_MCR2			9
#define	C54X_MCBSP_SBA_RCERA		0xa
#define	C54X_MCBSP_SBA_RCERB		0xb
#define	C54X_MCBSP_SBA_XCERA		0xc
#define	C54X_MCBSP_SBA_XCERB		0xd
#define	C54X_MCBSP_SBA_PCR			0xe


//-------- Timers --------
unsigned *C54X_TM_TIM	= (unsigned *)0x24;
unsigned *C54X_TM_PRD	= (unsigned *)0x25;
unsigned *C54X_TM_TCR	= (unsigned *)0x26;

unsigned *C54X_TM1_TIM	= (unsigned *)0x30;	// C5402 only !!!
unsigned *C54X_TM1_PRD	= (unsigned *)0x31;
unsigned *C54X_TM1_TCR	= (unsigned *)0x32;

//----------- GPIO control RGs (C5402 only) ----
unsigned *C54X_GPIOCR	= (unsigned *)0x3C;
unsigned *C54X_GPIOSR	= (unsigned *)0x3D;


//----- wait state control
unsigned *C54X_SWWSR= (unsigned *)0x28;
unsigned *C54X_BSCR	= (unsigned *)0x29;
unsigned *C54X_SWCR	= (unsigned *)0x2B;
unsigned *C54X_CLKMD= (unsigned *)0x58;

//----- HPIC 
unsigned *C54X_HPIC	= (unsigned *)0x2C;


//----- IMR/IFR
unsigned *C54X_IMR	= (unsigned *)0x0;
unsigned *C54X_IFR	= (unsigned *)0x1;

unsigned *C54X_ST0	= (unsigned *)0x6;
unsigned *C54X_ST1	= (unsigned *)0x7;
unsigned *C54X_PMST	= (unsigned *)0x1D;

#define C54X_SET_IPTR(a)			*C54X_PMST = ((*C54X_PMST)&0x7f) | (a &~0x7f)
#define C54X_IPTR					(*C54X_PMST &~0x7f)


//----- C54x CHIP ID reg (available for C5410, C5416, C5421 and later DSP)
unsigned *C54X_CSIDR	= (unsigned *)0x3e;


/************  C54x macros & IRQ control *****************/
#define C54X_CLR_XF					asm(" rsbx xf")
#define C54X_SET_XF					asm(" ssbx xf")

#define C54X_INT_DISABLE			asm(" ssbx intm")
#define C54X_INT_ENABLE				asm(" rsbx intm")

#define	C54X_IFR_CLEAR				*C54X_IFR =0xffff
#define	C54X_IMR_CLEAR				*C54X_IMR =0

#define	C54X_XINT0_ENABLE	 		*C54X_IMR |=  1
#define	C54X_XINT0_DISABLE			*C54X_IMR &= ~1
#define	C54X_XINT0_CLEAR			*C54X_IFR = 1
#define	C54X_IFR_XINT0_DATA			(*C54X_IFR &1)
#define	C54X_IMR_XINT0_DATA			(*C54X_IMFR &1)

#define	C54X_XINT1_ENABLE 			*C54X_IMR |=  2
#define	C54X_XINT1_DISABLE			*C54X_IMR &= ~2
#define	C54X_XINT1_CLEAR			*C54X_IFR = 2
#define	C54X_IFR_XINT1_DATA			(*C54X_IFR &2)
#define	C54X_IMR_XINT1_DATA			(*C54X_IMFR &2)

#define	C54X_XINT2_ENABLE 			*C54X_IMR |=  4
#define	C54X_XINT2_DISABLE			*C54X_IMR &= ~4
#define	C54X_XINT2_CLEAR			*C54X_IFR = 4
#define	C54X_IFR_XINT2_DATA			(*C54X_IFR &4)
#define	C54X_IMR_XINT2_DATA			(*C54X_IMFR &4)

#define	C54X_XINT3_ENABLE	 		*C54X_IMR |=  0x100
#define	C54X_XINT3_DISABLE			*C54X_IMR &= ~0x100
#define	C54X_XINT3_CLEAR			*C54X_IFR = 0x100
#define	C54X_IFR_XINT3_DATA			(*C54X_IFR &0x100)
#define	C54X_IMR_XINT3_DATA			(*C54X_IMFR &0x100)

#define	C54X_HPI_INT_ENABLE 		*C54X_IMR |=  0x200
#define	C54X_HPI_INT_DISABLE		*C54X_IMR &= ~0x200
#define	C54X_HPI_INT_CLEAR			*C54X_IFR = 0x200
#define	C54X_IFR_HPI_INT_DATA		(*C54X_IFR &0x200)
#define	C54X_IMR_HPI_INT_DATA		(*C54X_IMFR &0x200)

#define	C54X_TM_INT_ENABLE 			*C54X_IMR |=  8
#define	C54X_TM_INT_DISABLE			*C54X_IMR &= ~8
#define	C54X_TM_INT_CLEAR			*C54X_IFR = 8
#define	C54X_IFR_TM_INT_DATA		(*C54X_IFR &0x8)
#define	C54X_IMR_TM_INT_DATA		(*C54X_IMFR &0x8)

	// TM1 macros for C5402 DSP
#define	C54X_TM1_INT_ENABLE 		*C54X_IMR |=  0x80
#define	C54X_TM1_INT_DISABLE		*C54X_IMR &= ~0x80
#define	C54X_TM1_INT_CLEAR			*C54X_IFR = 0x80
#define	C54X_IFR_TM1_INT_DATA		(*C54X_IFR &0x80)
#define	C54X_IMR_TM1_INT_DATA		(*C54X_IMFR &0x80)


	// macros for C54x DSP with BSP/BSP1/TDM serial ports
#define	C54X_BSPR_INT_ENABLE 		*C54X_IMR |=  0x10
#define	C54X_BSPR_INT_DISABLE		*C54X_IMR &= ~0x10
#define	C54X_BSPR_INT_CLEAR			*C54X_IFR = 0x10
#define	C54X_IFR_BSPR_INT_DATA		(*C54X_IFR &0x10)
#define	C54X_IMR_BSPR_INT_DATA		(*C54X_IMFR &0x10)

#define	C54X_BSPX_INT_ENABLE 		*C54X_IMR |=  0x20
#define	C54X_BSPX_INT_DISABLE		*C54X_IMR &= ~0x20
#define	C54X_BSPX_INT_CLEAR			*C54X_IFR = 0x20
#define	C54X_IFR_BSPX_INT_DATA		(*C54X_IFR &0x20)
#define	C54X_IMR_BSPX_INT_DATA		(*C54X_IMFR &0x20)

#define	C54X_BSP1R_INT_ENABLE 		*C54X_IMR |=  0x400
#define	C54X_BSP1R_INT_DISABLE		*C54X_IMR &= ~0x400
#define	C54X_BSP1R_INT_CLEAR		*C54X_IFR = 0x400
#define	C54X_IFR_BSP1R_INT_DATA		(*C54X_IFR &0x400)
#define	C54X_IMR_BSP1R_INT_DATA		(*C54X_IMFR &0x400)

#define	C54X_BSP1X_INT_ENABLE	 	*C54X_IMR |=  0x800
#define	C54X_BSP1X_INT_DISABLE		*C54X_IMR &= ~0x800
#define	C54X_BSP1X_INT_CLEAR		*C54X_IFR = 0x800
#define	C54X_IFR_BSP1X_INT_DATA		(*C54X_IFR &0x800)
#define	C54X_IMR_BSP1X_INT_DATA		(*C54X_IMFR &0x800)

#define	C54X_TDMR_INT_ENABLE 		*C54X_IMR |=  0x40
#define	C54X_TDMR_INT_DISABLE		*C54X_IMR &= ~0x40
#define	C54X_TDMR_INT_CLEAR			*C54X_IFR = 0x40
#define	C54X_IFR_TDMR_INT_DATA		(*C54X_IFR &0x40)
#define	C54X_IMR_TDMR_INT_DATA		(*C54X_IMFR &0x40)

#define	C54X_TDMX_INT_ENABLE 		*C54X_IMR |=  0x80
#define	C54X_TDMX_INT_DISABLE		*C54X_IMR &= ~0x80
#define	C54X_TDMX_INT_CLEAR			*C54X_IFR = 0x80
#define	C54X_IFR_TDMX_INT_DATA		(*C54X_IFR &0x80)
#define	C54X_IMR_TDMX_INT_DATA		(*C54X_IMFR &0x80)

	// macros for C54xx DSP with McBSP serial ports
#define	C54X_MCBSP0R_INT_ENABLE 	*C54X_IMR |=  0x10
#define	C54X_MCBSP0R_INT_DISABLE	*C54X_IMR &= ~0x10
#define	C54X_MCBSP0R_INT_CLEAR		*C54X_IFR = 0x10
#define	C54X_IFR_MCBSP0R_INT_DATA	(*C54X_IFR &0x10)
#define	C54X_IMR_MCBSP0R_INT_DATA	(*C54X_IMFR &0x10)

#define	C54X_MCBSP0X_INT_ENABLE 	*C54X_IMR |=  0x20
#define	C54X_MCBSP0X_INT_DISABLE	*C54X_IMR &= ~0x20
#define	C54X_MCBSP0X_INT_CLEAR		*C54X_IFR = 0x20
#define	C54X_IFR_MCBSP0X_INT_DATA	(*C54X_IFR &0x20)
#define	C54X_IMR_MCBSP0X_INT_DATA	(*C54X_IMFR &0x20)

#define	C54X_MCBSP1R_INT_ENABLE 	*C54X_IMR |=  0x400
#define	C54X_MCBSP1R_INT_DISABLE	*C54X_IMR &= ~0x400
#define	C54X_MCBSP1R_INT_CLEAR		*C54X_IFR = 0x400
#define	C54X_IFR_MCBSP1R_INT_DATA	(*C54X_IFR &0x400)
#define	C54X_IMR_MCBSP1R_INT_DATA	(*C54X_IMFR &0x400)

#define	C54X_MCBSP1X_INT_ENABLE 	*C54X_IMR |=  0x800
#define	C54X_MCBSP1X_INT_DISABLE	*C54X_IMR &= ~0x800
#define	C54X_MCBSP1X_INT_CLEAR		*C54X_IFR = 0x800
#define	C54X_IFR_MCBSP1X_INT_DATA	(*C54X_IFR &0x800)
#define	C54X_IMR_MCBSP1X_INT_DATA	(*C54X_IMFR &0x800)

#define	C54X_MCBSP2R_INT_ENABLE 	*C54X_IMR |=  0x40
#define	C54X_MCBSP2R_INT_DISABLE	*C54X_IMR &= ~0x40
#define	C54X_MCBSP2R_INT_CLEAR		*C54X_IFR = 0x40
#define	C54X_IFR_MCBSP2R_INT_DATA	(*C54X_IFR &0x40)
#define	C54X_IMR_MCBSP2R_INT_DATA	(*C54X_IMFR &0x40)

#define	C54X_MCBSP2X_INT_ENABLE 	*C54X_IMR |=  0x80
#define	C54X_MCBSP2X_INT_DISABLE	*C54X_IMR &= ~0x80
#define	C54X_MCBSP2X_INT_CLEAR		*C54X_IFR = 0x80
#define	C54X_IFR_MCBSP2X_INT_DATA	(*C54X_IFR &0x80)
#define	C54X_IMR_MCBSP2X_INT_DATA	(*C54X_IMFR &0x80)

	// macros for DMA interrupts 
	// note: DMA IRQs are shared with other IRQs
#define	C54X_DMAC0_INT_ENABLE	 	*C54X_IMR |=  0x40
#define	C54X_DMAC0_INT_DISABLE		*C54X_IMR &= ~0x40
#define	C54X_DMAC0_INT_CLEAR		*C54X_IFR = 0x40
#define	C54X_IFR_DMAC0_INT_DATA		(*C54X_IFR &0x40)
#define	C54X_IMR_DMAC0_INT_DATA		(*C54X_IMFR &0x40)

#define	C54X_DMAC1_INT_ENABLE	 	*C54X_IMR |=  0x80
#define	C54X_DMAC1_INT_DISABLE		*C54X_IMR &= ~0x80
#define	C54X_DMAC1_INT_CLEAR		*C54X_IFR = 0x80
#define	C54X_IFR_DMAC1_INT_DATA		(*C54X_IFR &0x80)
#define	C54X_IMR_DMAC1_INT_DATA		(*C54X_IMFR &0x80)

#define	C54X_DMAC2_INT_ENABLE	 	*C54X_IMR |=  0x400
#define	C54X_DMAC2_INT_DISABLE		*C54X_IMR &= ~0x400
#define	C54X_DMAC2_INT_CLEAR		*C54X_IFR = 0x400
#define	C54X_IFR_DMAC2_INT_DATA		(*C54X_IFR &0x400)
#define	C54X_IMR_DMAC2_INT_DATA		(*C54X_IMFR &0x400)

#define	C54X_DMAC3_INT_ENABLE	 	*C54X_IMR |=  0x800
#define	C54X_DMAC3_INT_DISABLE		*C54X_IMR &= ~0x800
#define	C54X_DMAC3_INT_CLEAR		*C54X_IFR = 0x800
#define	C54X_IFR_DMAC3_INT_DATA		(*C54X_IFR &0x800)
#define	C54X_IMR_DMAC3_INT_DATA		(*C54X_IMFR &0x800)

#define	C54X_DMAC4_INT_ENABLE	 	*C54X_IMR |=  0x1000
#define	C54X_DMAC4_INT_DISABLE		*C54X_IMR &= ~0x1000
#define	C54X_DMAC4_INT_CLEAR		*C54X_IFR = 0x1000
#define	C54X_IFR_DMAC4_INT_DATA		(*C54X_IFR &0x1000)
#define	C54X_IMR_DMAC4_INT_DATA		(*C54X_IMFR &0x1000)

#define	C54X_DMAC5_INT_ENABLE	 	*C54X_IMR |=  0x2000
#define	C54X_DMAC5_INT_DISABLE		*C54X_IMR &= ~0x2000
#define	C54X_DMAC5_INT_CLEAR		*C54X_IFR = 0x2000
#define	C54X_IFR_DMAC5_INT_DATA		(*C54X_IFR &0x2000)
#define	C54X_IMR_DMAC5_INT_DATA		(*C54X_IMFR &0x2000)

	// macros for 'C5421 IPINT control (inter-core interrupt)
#define	C542X_IPINT_ENABLE	 		*C54X_IMR |=  0x4000
#define	C542X_IPINT_DISABLE			*C54X_IMR &= ~0x4000
#define	C542X_IPINT_SET				{*C54X_BSCR &= ~0x0100;*C54X_BSCR |= 0x0100;}
#define	C542X_IPINT_CLEAR			{*C54X_BSCR &= ~0x0100;*C54X_IFR = 0x4000;}
#define	C542X_IFR_IPINT_DATA		(*C54X_IFR &0x4000)
#define	C542X_IMR_IPINT_DATA		(*C54X_IMFR &0x4000)
//---------------------------------------------------------



//--------------- HPIC defs and access macros -------------

	// HINT can be set-only by DSP core and cleared by HOST
#define	C54X_HPIC_HINT_BITMASK		0x8
#define	C54X_HPIC_HINT_ON			0x8
#define	C54X_HPIC_HINT_OFF			0
#define	C542X_HPIC_HINT_BITMASK		0x4
#define	C542X_HPIC_HINT_ON			0x4
#define	C542X_HPIC_HINT_OFF			0

	// SMOD must be set for C548/C549 in order to allow DSP access to HPIC area
#define	C54X_HPIC_SMOD_BITMASK		0x2
#define	C54X_HPIC_SMOD_ON			0x2
#define	C54X_HPIC_SMOD_OFF			0

	// macros for HINT access
#define C54X_SET_HPIC_HINT			*C54X_HPIC |= C54X_HPIC_HINT_ON;
#define C54X_HPIC_HINT_DATA			(*C54X_HPIC & C54X_HPIC_HINT_BITMASK)
#define C542X_SET_HPIC_HINT			*C54X_HPIC |= C542X_HPIC_HINT_ON;
#define C542X_HPIC_HINT_DATA		(*C54X_HPIC & C542X_HPIC_HINT_BITMASK)

	// this macros must be executed in order to enable DSP to access HPI shared area
#define C54X_INIT_HPIC				*C54X_HPIC |= C54X_HPIC_SMOD_ON;

//---------------------------------------------------------


//----------- GPIO-CR/SR I/O control register defs -----------
	//--- 'C5402 GPIO-CR register bits
#define	 C5402_GPIOCR_TOUT1_BITMASK			0x8000	// timer #1 enable bitmask
#define	 C5402_GPIOCR_TOUT1_EN_BITMASK		0x8000	// timer #1 enable bitmask
#define	 C5402_GPIOCR_TOUT1_EN_ON			0x8000	// enable timer #1
#define	 C5402_GPIOCR_TOUT1_EN_OFF			0		// disable timer #1

	//--- dual-core 'C542x GPIO-CR register bits
#define	 C542X_GPIOCR_TOUT_EN_BITMASK		0x8000	// bitmask for timer enable at GPIO3 pin
#define	 C542X_GPIOCR_TOUT_EN_OFF			0		// disable timer at GPIO3 pin
#define	 C542X_GPIOCR_TOUT_EN_ON			0x8000	// enable timer at GPIO3 pin

#define	 C542X_GPIOCR_GPIO0_DIR_BITMASK		0x0100	// GPIO-0 direction control bitmask
#define	 C542X_GPIOCR_GPIO0_DIR_IN			0		// GPIO-0 INPUT direction cnf
#define	 C542X_GPIOCR_GPIO0_DIR_OUT			0x0100	// GPIO-0 OUTPUT direction cnf
#define	 C542X_GPIOCR_GPIO1_DIR_BITMASK		0x0200	// GPIO-1 direction control bitmask
#define	 C542X_GPIOCR_GPIO1_DIR_IN			0		// GPIO-1 INPUT direction cnf
#define	 C542X_GPIOCR_GPIO1_DIR_OUT			0x0200	// GPIO-1 OUTPUT direction cnf
#define	 C542X_GPIOCR_GPIO2_DIR_BITMASK		0x0400	// GPIO-2 direction control bitmask
#define	 C542X_GPIOCR_GPIO2_DIR_IN			0		// GPIO-2 INPUT direction cnf
#define	 C542X_GPIOCR_GPIO2_DIR_OUT			0x0400	// GPIO-2 OUTPUT direction cnf
#define	 C542X_GPIOCR_GPIO3_DIR_BITMASK		0x0800	// GPIO-3 direction control bitmask
#define	 C542X_GPIOCR_GPIO3_DIR_IN			0		// GPIO-3 INPUT direction cnf
#define	 C542X_GPIOCR_GPIO3_DIR_OUT			0x0800	// GPIO-3 OUTPUT direction cnf

#define	 C542X_GPIOCR_GPIO0_DATA_BITMASK	0x0001	// GPIO-0 data bitmask
#define	 C542X_GPIOCR_GPIO0_DATA_OFF		0		// GPIO-0 '0' I/O data
#define	 C542X_GPIOCR_GPIO0_DATA_ON			0x0001	// GPIO-0 '1' I/O data
#define	 C542X_GPIOCR_GPIO1_DATA_BITMASK	0x0002	// GPIO-1 data bitmask
#define	 C542X_GPIOCR_GPIO1_DATA_OFF		0		// GPIO-1 '0' I/O data
#define	 C542X_GPIOCR_GPIO1_DATA_ON			0x0002	// GPIO-1 '1' I/O data
#define	 C542X_GPIOCR_GPIO2_DATA_BITMASK	0x0004	// GPIO-2 data bitmask
#define	 C542X_GPIOCR_GPIO2_DATA_OFF		0		// GPIO-2 '0' I/O data
#define	 C542X_GPIOCR_GPIO2_DATA_ON			0x0004	// GPIO-2 '1' I/O data
#define	 C542X_GPIOCR_GPIO3_DATA_BITMASK	0x0008	// GPIO-3 data bitmask
#define	 C542X_GPIOCR_GPIO3_DATA_OFF		0		// GPIO-3 '0' I/O data
#define	 C542X_GPIOCR_GPIO3_DATA_ON			0x0008	// GPIO-3 '1' I/O data

#define	 C542X_GPIOCR_ROMEN_BITMASK			0x0080	// r/w: ROMEN data bitmask
#define	 C542X_GPIOCR_ROMEN_OFF				0		// ROMEN '0' state
#define	 C542X_GPIOCR_ROMEN_ON				0x0080	// ROMEN '1' state

#define	 C542X_GPIOCR_CORESEL_BITMASK		0x0040	// r-only: CORE SEL data bitmask
#define	 C542X_GPIOCR_CORESEL_A				0		// CORE SEL 'A' state
#define	 C542X_GPIOCR_CORESEL_B				0x0040	// CORE SEL 'B' state

#define	 C542X_GPIOCR_XIOGRANT_BITMASK		0x0020	// r-only: XIOGRANT data bitmask
#define	 C542X_GPIOCR_XIOGRANT_OFF			0		// XIOGRANT '0' state
#define	 C542X_GPIOCR_XIOGRANT_ON			0x0020	// XIOGRANT '1' state

#define	 C542X_GPIOCR_XIORQ_BITMASK			0x0010	// r/w: XIO-RQ data bitmask
#define	 C542X_GPIOCR_XIORQ_OFF				0		// XIO-RQ '0' state
#define	 C542X_GPIOCR_XIORQ_ON				0x0010	// XIO-RQ '1' state

	//--- GPIOC access macros
#define	C542X_TOUT_EN_DATA				 	(*C54X_GPIOCR & C542X_GPIOCR_TOUT_EN_BITMASK)
#define	C542X_SET_TOUT_EN_OFF			 	(*C54X_GPIOCR &= ~C542X_GPIOCR_TOUT_EN_BITMASK)
#define	C542X_SET_TOUT_EN_ON			 	(*C54X_GPIOCR |= C542X_GPIOCR_TOUT_EN_BITMASK)

#define	C542X_GPIO0_DIR_DATA			 	(*C54X_GPIOCR & C542X_GPIOCR_GPIO0_DIR_BITMASK)
#define	C542X_GPIO1_DIR_DATA			 	(*C54X_GPIOCR & C542X_GPIOCR_GPIO1_DIR_BITMASK)
#define	C542X_GPIO2_DIR_DATA			 	(*C54X_GPIOCR & C542X_GPIOCR_GPIO2_DIR_BITMASK)
#define	C542X_GPIO3_DIR_DATA			 	(*C54X_GPIOCR & C542X_GPIOCR_GPIO3_DIR_BITMASK)

#define	C542X_SET_GPIO0_DIR_IN			 	(*C54X_GPIOCR &= ~C542X_GPIOCR_GPIO0_DIR_BITMASK)
#define	C542X_SET_GPIO0_DIR_OUT			 	(*C54X_GPIOCR |= C542X_GPIOCR_GPIO0_DIR_BITMASK)
#define	C542X_SET_GPIO1_DIR_IN			 	(*C54X_GPIOCR &= ~C542X_GPIOCR_GPIO1_DIR_BITMASK)
#define	C542X_SET_GPIO1_DIR_OUT			 	(*C54X_GPIOCR |= C542X_GPIOCR_GPIO1_DIR_BITMASK)
#define	C542X_SET_GPIO2_DIR_IN			 	(*C54X_GPIOCR &= ~C542X_GPIOCR_GPIO2_DIR_BITMASK)
#define	C542X_SET_GPIO2_DIR_OUT			 	(*C54X_GPIOCR |= C542X_GPIOCR_GPIO2_DIR_BITMASK)
#define	C542X_SET_GPIO3_DIR_IN			 	(*C54X_GPIOCR &= ~C542X_GPIOCR_GPIO3_DIR_BITMASK)
#define	C542X_SET_GPIO3_DIR_OUT			 	(*C54X_GPIOCR |= C542X_GPIOCR_GPIO3_DIR_BITMASK)

#define	C542X_GPIO0_DATA_DATA			 	(*C54X_GPIOCR & C542X_GPIOCR_GPIO0_DATA_BITMASK)
#define	C542X_GPIO1_DATA_DATA			 	(*C54X_GPIOCR & C542X_GPIOCR_GPIO1_DATA_BITMASK)
#define	C542X_GPIO2_DATA_DATA			 	(*C54X_GPIOCR & C542X_GPIOCR_GPIO2_DATA_BITMASK)
#define	C542X_GPIO3_DATA_DATA			 	(*C54X_GPIOCR & C542X_GPIOCR_GPIO3_DATA_BITMASK)

#define	C542X_SET_GPIO0_DATA_OFF		 	(*C54X_GPIOCR &= ~C542X_GPIOCR_GPIO0_DATA_BITMASK)
#define	C542X_SET_GPIO0_DATA_ON			 	(*C54X_GPIOCR |= C542X_GPIOCR_GPIO0_DATA_BITMASK)
#define	C542X_SET_GPIO1_DATA_OFF		 	(*C54X_GPIOCR &= ~C542X_GPIOCR_GPIO1_DATA_BITMASK)
#define	C542X_SET_GPIO1_DATA_ON			 	(*C54X_GPIOCR |= C542X_GPIOCR_GPIO1_DATA_BITMASK)
#define	C542X_SET_GPIO2_DATA_OFF		 	(*C54X_GPIOCR &= ~C542X_GPIOCR_GPIO2_DATA_BITMASK)
#define	C542X_SET_GPIO2_DATA_ON			 	(*C54X_GPIOCR |= C542X_GPIOCR_GPIO2_DATA_BITMASK)
#define	C542X_SET_GPIO3_DATA_OFF		 	(*C54X_GPIOCR &= ~C542X_GPIOCR_GPIO3_DATA_BITMASK)
#define	C542X_SET_GPIO3_DATA_ON			 	(*C54X_GPIOCR |= C542X_GPIOCR_GPIO3_DATA_BITMASK)

//-----------------------------------------------------------------

//------------ C54X Chip/Subsystem ID register defs ---------------
#define	 C54X_CSIDR_DEV_ID_BITMASK		0xff00	// device ID bitmask
#define	 C54X_CSIDR_DEV_ID_C5410		0x1000	// C5410 device ID
#define	 C54X_CSIDR_DEV_ID_C5416		0x1600	// C5416 device ID
#define	 C54X_CSIDR_DEV_ID_C5421		0x2100	// C5421 device ID

#define	 C54X_CSIDR_DEV_REV_BITMASK		0x00f0	// device revision bitmask

#define	 C54X_CSIDR_SUBSYS_ID_BITMASK	0x000f	// multi-core subsystem ID bitmask
#define	 C54X_CSIDR_SUBSYS_ID_A			0x0000	// DSP-A core ID
#define	 C54X_CSIDR_SUBSYS_ID_B			0x0001	// DSP-B core ID
#define	 C542X_CSIDR_SUBSYS_ID_A		0x0000	// DSP-A core ID for C542x
#define	 C542X_CSIDR_SUBSYS_ID_B		0x0001	// DSP-B core ID for C542x
//-----------------------------------------------------------------



/************  C54x specific memory areas *****************/

#define	C54X_PMEM_AREA		0
#define	C54X_DMEM_AREA		1
#define	C54X_IO_AREA		2

/*--- C54x HPI areas -----*/

#define	C54X_HPI_SADDR		0x1000	/* valid for C542/C548/C549 */
#define	C54X_HPI_EADDR		0x17ff

#define	C542_HPI_SADDR		0x1000
#define	C542_HPI_EADDR		0x17ff
#define	C548_HPI_SADDR		0x1000
#define	C548_HPI_EADDR		0x17ff
#define	C549_HPI_SADDR		0x1000
#define	C549_HPI_EADDR		0x17ff
#define	C5402_HPI_SADDR		0x0000
#define	C5402_HPI_EADDR		0x3fff
#define	C5410_HPI_SADDR		0x0000	// standard HPI area
#define	C5410_HPI_EADDR		0x7fff
#define	C5410_XHPI_SADDR	0x8000	// extended HPI: SARAM2 block (DROM=1)
#define	C5410_XHPI_EADDR	0xffff
#define	C5416_HPI_SADDR		0x0000	// standard HPI area
#define	C5416_HPI_EADDR		0x7fff
#define	C5416_XHPI_SADDR	0x8000	// extended HPI: SARAM2 block (DROM=1)
#define	C5416_XHPI_EADDR	0xffff
#define	C542X_HPI_SADDR		0x0000	// standard HPI area
#define	C542X_HPI_EADDR		0x7fff
#define	C542X_XHPI_SADDR	0x8000	// extended HPI: SDARAM0..3 blocks, SARAM
#define	C542X_XHPI_EADDR	0xffff

/*-- C54x memory areas -------*/

#define	C54X_MMR_SADDR		0x0000
#define	C54X_MMR_EADDR		0x005f
#define	C54X_MMR_LEN		0x0060
#define	C54X_SCRATCH_PAD_SADDR	0x0060
#define	C54X_SCRATCH_PAD_EADDR	0x007f
#define	C54X_SCRATCH_PAD_LEN	0x0020

/*-- C54x on-chip DATA-RAM definitions
     (might be mapped to PRG-MEM via OVLY and DROM bits of PMST register)
*/
#define	C54X_DARAM_SADDR	0x0080	
#define	C542_DARAM_EADDR	0x27ff
#define	C542_DARAM_LEN		0x2780
#define	C548_DARAM_EADDR	0x7fff
#define	C548_DARAM_LEN		0x7f80
#define	C549_DARAM_EADDR	0x7fff
#define	C549_DARAM_LEN		0x7f80
#define	C5402_DARAM_EADDR	0x3fff
#define	C5402_DARAM_LEN		0x3f80
#define	C5410_DARAM_EADDR	0x7fff
#define	C5410_DARAM_LEN		0x7f80
#define	C5410_DARAM2_SADDR	0x8000
#define	C5410_DARAM2_EADDR	0xffff
#define	C5410_DARAM2_LEN	0x8000
#define	C5416_DARAM_EADDR	0x7fff
#define	C5416_DARAM_LEN		0x7f80
#define	C5416_DARAM2_SADDR	0x8000
#define	C5416_DARAM2_EADDR	0xffff
#define	C5416_DARAM2_LEN	0x8000
#define	C542X_DARAM_EADDR	0x7fff
#define	C542X_DARAM_LEN		0x7f80
#define	C542X_DARAM2_SADDR	0x8000
#define	C542X_DARAM2_EADDR	0xffff
#define	C542X_DARAM2_LEN	0x8000
#define	C5420_DARAM_EADDR	0x7fff
#define	C5420_DARAM_LEN		0x7f80
#define	C5420_DARAM2_SADDR	0x8000
#define	C5420_DARAM2_EADDR	0xffff
#define	C5420_DARAM2_LEN	0x8000
#define	C5421_DARAM_EADDR	0x7fff
#define	C5421_DARAM_LEN		0x7f80
#define	C5421_DARAM2_SADDR	0x8000
#define	C5421_DARAM2_EADDR	0xffff
#define	C5421_DARAM2_LEN	0x8000


/*--- external DATA-RAM areas ---*/
#define	C542_XDRAM_SADDR	0x2800
#define	C548_XDRAM_SADDR	0x8000
#define	C549_XDRAM_SADDR	0x8000
#define	C5402_XDRAM_SADDR	0x4000
#define	C5410_XDRAM_SADDR	0x8000
#define	C5416_XDRAM_SADDR	0x8000
#define	C542X_XDRAM_SADDR	0x8000
#define	C5420_XDRAM_SADDR	0x8000
#define	C5421_XDRAM_SADDR	0x8000
#define	C54X_XDRAM_EADDR	0xffff


#endif
